| QxOrm 1.2.7 C++ Object Relational Mapping library

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes
qx::QxModel< T > Class Template Reference
QxModelView : All classes registered into QxOrm context can be used with Qt model/view architecture (Qt widgets and/or QML views)

qx::QxModel<T> : all classes registered into QxOrm context can be used with Qt model/view architecture (Qt widgets and/or QML views) More...

`#include <QxModel.h>`

Inheritance diagram for qx::QxModel< T >:

List of all members.

## Public Types
enum | { qx_is_valid = qx::trait::is_qx_registered<T>::value }
typedef boost::shared_ptr< T > | type_ptr
typedef qx::trait::get_primary_key< T > ::type | type_primary_key
typedef qx::QxCollection < type_primary_key, type_ptr > | type_collection
## Public Member Functions
| QxModel (QObject *parent=0)
virtual | ~QxModel ()
virtual QVariant | data (const QModelIndex &index, int role=Qt::DisplayRole) const
virtual bool | setData (const QModelIndex &index, const QVariant &value, int role=Qt::EditRole)
virtual bool | insertRows (int row, int count, const QModelIndex &parent=QModelIndex())
virtual long | qxCount (const qx::QxSqlQuery &query=qx::QxSqlQuery(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxCount (long &lCount, const qx::QxSqlQuery &query=qx::QxSqlQuery(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxFetchById (const QVariant &id, const QStringList &relation=QStringList(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxFetchAll (const QStringList &relation=QStringList(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxFetchByQuery (const qx::QxSqlQuery &query, const QStringList &relation=QStringList(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxInsert (const QStringList &relation=QStringList(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxUpdate (const qx::QxSqlQuery &query=qx::QxSqlQuery(), const QStringList &relation=QStringList(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxSave (const QStringList &relation=QStringList(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxSaveRow (int row, const QStringList &relation=QStringList(), QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxDeleteById (const QVariant &id, QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxDeleteAll (QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxDeleteByQuery (const qx::QxSqlQuery &query, QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxDestroyById (const QVariant &id, QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxDestroyAll (QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxDestroyByQuery (const qx::QxSqlQuery &query, QSqlDatabase *pDatabase=NULL)
virtual QSqlError | qxExecuteQuery (qx::QxSqlQuery &query, QSqlDatabase *pDatabase=NULL)
virtual qx_bool | qxExist (const QVariant &id, QSqlDatabase *pDatabase=NULL)
virtual qx::QxInvalidValueX | qxValidate (const QStringList &groups=QStringList())
## Protected Member Functions
void | init ()
## Protected Attributes
type_collection | m_model
| Model associated to a class registered into QxOrm context.
long | m_lManualInsertIndex
| Index to insert manually items to the collection.

## Detailed Description

### template<class T>
class qx::QxModel< T >

qx::QxModel<T> : all classes registered into QxOrm context can be used with Qt model/view architecture (Qt widgets and/or QML views)

QxModelView module provides an easy way to work with Qt model/view engine with all classes registered into QxOrm context :

- Qt widgets : QTableView or QListView for example to display/modify a database table content ;
- QML : each property defined in QxOrm context is exposed to QML engine : QxModelView module makes easier integration between QML and databases.

qx::IxModel interface provides a generic way for all models linked to persistents classes registered into QxOrm context. All methods of this class prefixed by qx call functions from qx::dao namespace and then communicate with database.

The qxBlogModelView sample project in ./test/ directory of QxOrm package shows how to create quickly a model and associate it to the Qt model/view engine (first with a Qt widget, then with a QML view).

1- Here is an example to display/modify data from 'author' table (go to qxBlog tutorial for 'author' class definition) in a QTableView :

    // Create a model and fetch all data from database
    qx::IxModel * pModel = new qx::QxModel<author>();
    pModel->qxFetchAll();

    // Associate the model to a QTableView and display it
    QTableView tableView;
    tableView.setModel(pModel);
    tableView.show();

2- Here is another example in QML (with Qt5, QxModelView module works fine with Qt4 too) :

    // Create a model and fetch all data from database
    qx::IxModel * pModel = new qx::QxModel<author>();
    pModel->qxFetchAll();

    // Associate the model to a QML view and display it
    QQuickView qmlView;
    qmlView.rootContext()->setContextProperty("myModel", pModel);
    qmlView.setSource(QUrl("qrc:/documents/main.qml"));
    qmlView.show();

And here is the 'main.qml' file content :

    import QtQuick 2.1
    import QtQuick.Controls 1.0

    Item {
       width: 400
       height: 300
       Row {
          height: 20
          spacing: 20
          Button {
             text: "Clear"
             onClicked: myModel.clear()
          }
          Button {
             text: "Fetch All"
             onClicked: myModel.qxFetchAll_()
          }
          Button {
             text: "Save"
             onClicked: myModel.qxSave_()
          }
       }
       ListView {
          y: 30
          height: 270
          model: myModel
          delegate: Row {
             height: 20
             spacing: 10
             Text { text: "id: " + author_id }
             TextField {
                text: name
                onTextChanged: name = text
             }
          }
       }
    }

As you can see in the 'main.qml' file, 'author_id' and 'name' properties of 'author' model ('myModel' variable) can be automatically read and write (because they are registered into QxOrm context). Moreover, qx::IxModel interface provides a list of methods for QML side (Q_INVOKABLE) to communicate with database : for example, the 'Save' button will save the model in database without having to write a C++ function.

Note : a QxEntityEditor plugin generates automatically the code to manage models with relationships. Then it is possible to work with nested C++ models.

Definition at line 141 of file QxModel.h.

## Member Typedef Documentation

template<class T >

typedef qx::QxCollection<type_primary_key, type_ptr> qx::QxModel< T >::type_collection

Definition at line 148 of file QxModel.h.

template<class T >

typedef qx::trait::get_primary_key<T>::type qx::QxModel< T >::type_primary_key

Definition at line 147 of file QxModel.h.

template<class T >

typedef boost::shared_ptr<T> qx::QxModel< T >::type_ptr

Definition at line 146 of file QxModel.h.

## Member Enumeration Documentation

template<class T >

anonymous enum

Enumerator:

  qx_is_valid |

Definition at line 150 of file QxModel.h.

## Constructor & Destructor Documentation

template<class T >

qx::QxModel< T >::QxModel | ( | QObject * | parent = `0` | ) | `[inline]`

Definition at line 159 of file QxModel.h.

template<class T >

virtual qx::QxModel< T >::~QxModel | ( |  | ) | `[inline, virtual]`

Definition at line 160 of file QxModel.h.

## Member Function Documentation

template<class T >

virtual QVariant qx::QxModel< T >::data | ( | const QModelIndex & | index,
|  | int | role = `Qt::DisplayRole`
| ) |  | const`[inline, virtual]`

Definition at line 176 of file QxModel.h.

template<class T >

void qx::QxModel< T >::init | ( |  | ) | `[inline, protected]`

Definition at line 164 of file QxModel.h.

template<class T >

virtual bool qx::QxModel< T >::insertRows | ( | int | row,
|  | int | count,
|  | const QModelIndex & | parent = `QModelIndex()`
| ) |  | `[inline, virtual]`

Definition at line 220 of file QxModel.h.

template<class T >

virtual long qx::QxModel< T >::qxCount | ( | const qx::QxSqlQuery & | query = `qx::QxSqlQuery()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 239 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxCount | ( | long & | lCount,
|  | const qx::QxSqlQuery & | query = `qx::QxSqlQuery()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 244 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxDeleteAll | ( | QSqlDatabase * | pDatabase = `NULL` | ) | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 335 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxDeleteById | ( | const QVariant & | id,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 325 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxDeleteByQuery | ( | const qx::QxSqlQuery & | query,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 341 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxDestroyAll | ( | QSqlDatabase * | pDatabase = `NULL` | ) | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 357 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxDestroyById | ( | const QVariant & | id,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 347 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxDestroyByQuery | ( | const qx::QxSqlQuery & | query,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 363 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxExecuteQuery | ( | qx::QxSqlQuery & | query,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 369 of file QxModel.h.

template<class T >

virtual qx_bool qx::QxModel< T >::qxExist | ( | const QVariant & | id,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 381 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxFetchAll | ( | const QStringList & | relation = `QStringList()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 269 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxFetchById | ( | const QVariant & | id,
|  | const QStringList & | relation = `QStringList()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 250 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxFetchByQuery | ( | const qx::QxSqlQuery & | query,
|  | const QStringList & | relation = `QStringList()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 282 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxInsert | ( | const QStringList & | relation = `QStringList()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 295 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxSave | ( | const QStringList & | relation = `QStringList()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 309 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxSaveRow | ( | int | row,
|  | const QStringList & | relation = `QStringList()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 316 of file QxModel.h.

template<class T >

virtual QSqlError qx::QxModel< T >::qxUpdate | ( | const qx::QxSqlQuery & | query = `qx::QxSqlQuery()`,
|  | const QStringList & | relation = `QStringList()`,
|  | QSqlDatabase * | pDatabase = `NULL`
| ) |  | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 302 of file QxModel.h.

template<class T >

virtual qx::QxInvalidValueX qx::QxModel< T >::qxValidate | ( | const QStringList & | groups = `QStringList()` | ) | `[inline, virtual]`

Implements qx::IxModel.

Definition at line 390 of file QxModel.h.

template<class T >

virtual bool qx::QxModel< T >::setData | ( | const QModelIndex & | index,
|  | const QVariant & | value,
|  | int | role = `Qt::EditRole`
| ) |  | `[inline, virtual]`

Definition at line 196 of file QxModel.h.

## Member Data Documentation

template<class T >

long qx::QxModel< T >::m_lManualInsertIndex`[protected]`

Index to insert manually items to the collection.

Definition at line 155 of file QxModel.h.

template<class T >

type_collection qx::QxModel< T >::m_model`[protected]`

Model associated to a class registered into QxOrm context.

Definition at line 154 of file QxModel.h.

The documentation for this class was generated from the following file:

- D:/Dvlp/_Perso/QxOrm/include/QxModelView/QxModel.h